/*****************************************************************************/
/*                      WiNRADiO G35DDC EXCALIBUR ULTRA                      */
/*                                SDK DEMO                                   */
/*                        (C) Copyright RADIXON 2017                         */
/*****************************************************************************/

#ifndef __U_DEVICE_PANEL_H__
#define __U_DEVICE_PANEL_H__

#include <wx/wx.h>
#include <wx/sizer.h>
#include <wx/tglbtn.h>
#include <wx/combobox.h>
#include "G35DDCAPI.h"
#include "u_types.h"
#include "u_spectrum.h"
#include "u_fft.h"

class TMainWindow;

class TDevicePanel:public wxPanel
{
public:
    void __stdcall DDC1StreamCallback(CONST VOID *Buffer,UINT32 NumberOfSamples,UINT32 BitsPerSample);
    void __stdcall IFCallback(CONST SHORT *Buffer,UINT32 NumberOfSamples,WORD MaxADCAmplitude,UINT32 ADCSamplingRate);

    void UpdateControls(void);
    void UpdateDDC1(void);
    void UpdateDDC1Frequency(void);

    TDevicePanel(TMainWindow *MainWindow,ICohG35DDCDeviceSet *DeviceSet,uint32_t DeviceIndex);
    ~TDevicePanel(void);
protected:
private:
    ICohG35DDCDeviceSet     *m_DeviceSet;
    uint32_t                m_DeviceIndex;
    TMainWindow             *m_MainWindow;
    wxStaticText            *m_LSerNum;
    TSpectrum               *m_DDC1Spectrum;
    TFFTBuffer              m_DDC1FFTOverlappingBuffer;
    float                   m_DDC1FFTCoeffs[FFT_SIZE];
    float                   m_DDC1FFTCompensation[FFT_SIZE];
    float                   m_DDC1FFTBuffer[2*FFT_SIZE];
    wxMutex                 m_DDC1FFTMutex;
    G3XDDC_DDC_INFO         m_DDC1Info;

    TSpectrum               *m_IFSpectrum;
    float                   m_IFFFTBuffer[2*FFT_SIZE];
    float                   m_IFFFTCoeffs[FFT_SIZE];
    float                   m_IFFFTCompensation[FFT_SIZE/2];

    
    void UpdateDDC1FFTCompensation(void);

    void OnSpectrumTune(TSpectrumTuneEvent &Event);

    DECLARE_EVENT_TABLE()
};

#endif

